(define (domain rpg-domain-soldier-liter)
  (:requirements :typing :durative-actions :equality :fluents :negative-preconditions :disjunctive-preconditions :timed-initial-literals)
  (:types location city - location village - location person man - person woman - person)
  (:constants City1 City2 City3 City4 City5 City6 City7 City8 City9 City10 - city Village - village)
  (:functions
      (number_thrown_take_part_City1_battle ?p - person)
      (number_thrown_take_part_City2_battle ?p - person)
      (number_thrown_take_part_City3_battle ?p - person)
      (number_thrown_take_part_City4_battle ?p - person)
      (number_thrown_take_part_City5_battle ?p - person)
      (number_thrown_take_part_City6_battle ?p - person)
      (number_thrown_take_part_City7_battle ?p - person)
      (number_thrown_take_part_City8_battle ?p - person)
      (number_thrown_take_part_City9_battle ?p - person)
      (number_thrown_take_part_City10_battle ?p - person)
      (battles_count ?p - person)
  )
  (:predicates
      (at_place ?l - location ?p - person)
      (move_goal ?place1 - location ?place2 - location ?person - person)
      (married ?p - person)
      (divorced ?p - person)
      (have_met ?p1 ?p2 - person)
      (meet_goal ?p1 ?p2 - person)
      (have_relationship ?m - man ?w - woman)
      (date_goal ?m - man ?w - woman)
      (get_married_goal ?m - man ?w - woman ?l - location)
      (are_married ?m - man ?w - woman)
      (are_divorced ?m - man ?w - woman)
      (get_divorced_goal ?m - man ?w - woman ?l - location)
      (had_affair ?m - man ?w - woman)
      (have_short_affair_goal ?m - man ?w - woman)
      (have_very_short_affair_goal ?m - man ?w - woman)
      (have_long_affair_goal ?m - man ?w - woman)
      (soldier ?p - person)
      (lieutenant ?p - person)
      (captain ?p - person)
      (colonel ?p - person)
      (general ?p - person)
      (be_ascended_to_lieutenant_goal ?p - person)
      (be_ascended_to_captain_goal ?p - person)
      (be_ascended_to_colonel_goal ?p - person)
      (be_ascended_to_general_goal ?p - person)
      (studying_military_academy ?p - person)
      (study_military_academy_in_City10_goal ?p - person)
      (learn_a_trick_goal ?p - person)
      (learn_other_trick_goal ?p - person)
      (take_part_City1_battle_going_on)
      (take_part_City1_battle_init ?p - person)
      (take_part_City1_battle_goal ?p - person)
      (take_part_City2_battle_going_on)
      (take_part_City2_battle_init ?p - person)
      (take_part_City2_battle_goal ?p - person)
      (take_part_City3_battle_going_on)
      (take_part_City3_battle_init ?p - person)
      (take_part_City3_battle_goal ?p - person)
      (take_part_City4_battle_going_on)
      (take_part_City4_battle_init ?p - person)
      (take_part_City4_battle_goal ?p - person)
      (take_part_City5_battle_going_on)
      (take_part_City5_battle_init ?p - person)
      (take_part_City5_battle_goal ?p - person)
      (take_part_City6_battle_going_on)
      (take_part_City6_battle_init ?p - person)
      (take_part_City6_battle_goal ?p - person)
      (take_part_City7_battle_going_on)
      (take_part_City7_battle_init ?p - person)
      (take_part_City7_battle_goal ?p - person)
      (take_part_City8_battle_going_on)
      (take_part_City8_battle_init ?p - person)
      (take_part_City8_battle_goal ?p - person)
      (take_part_City9_battle_going_on)
      (take_part_City9_battle_init ?p - person)
      (take_part_City9_battle_goal ?p - person)
      (take_part_City10_battle_going_on)
      (take_part_City10_battle_init ?p - person)
      (take_part_City10_battle_goal ?p - person)
  )
  (:durative-action move
		    :parameters (?place1 ?place2 - location ?person - person)
  	    :duration (= ?duration 3)
		    :condition (at start (at_place ?place1 ?person))
		    :effect 
		      (and
		        (at start (not (at_place ?place1 ?person)))
            (at end (at_place ?place2 ?person))
            (at end (move_goal ?place1 ?place2 ?person))
          )
  )
  (:durative-action meet
		    :parameters (?p1 ?p2 - person ?l - location)
		    :duration (= ?duration 1)
		    :condition
          (and
            (over all (at_place ?l ?p1))
            (over all (at_place ?l ?p2))
          )
		    :effect 
          (and
            (at end (have_met ?p1 ?p2))
            (at end (have_met ?p2 ?p1))
            (at end (meet_goal ?p2 ?p1))
          )
  )
  (:durative-action date
		    :parameters (?m - man ?w - woman)
		    :duration (= ?duration 200)
		    :condition 
          (and
            (at start (have_met ?m ?w))
            (over all (not (married ?m)))
            (over all (not (married ?w)))
          )
		    :effect 
		      (and
            (at end (have_relationship ?m ?w))
            (at end (date_goal ?m ?w))
          )
  )
  (:durative-action get_married
		    :parameters (?m - man ?w - woman ?l - location)
		    :duration (= ?duration 1)
		    :condition
          (and
            (at start (have_relationship ?m ?w))
            (at start (not (married ?m)))
            (at start (not (married ?w)))
            (over all (at_place ?l ?m))
            (over all (at_place ?l ?w))
          )
		    :effect
          (and
            (at start (are_married ?m ?w))
            (at start (married ?m))
            (at start (married ?w))
            (at end (get_married_goal ?m ?w ?l))
          )
  )
  (:durative-action get_divorced
		    :parameters (?m - man ?w - woman ?l - location)
		    :duration (= ?duration 1)
		    :condition
          (and
            (at start (are_married ?m ?w))
            (over all (at_place ?l ?m))
            (over all (at_place ?l ?w))
          )
		    :effect
          (and
            (at end (are_divorced ?m ?w))
            (at end (not (are_married ?m ?w)))
            (at end (divorced ?m))
            (at end (divorced ?w))
            (at end (not (married ?m)))
            (at end (not (married ?w)))
            (at end (get_divorced_goal ?m ?w ?l))
          )
  )
  (:durative-action have_short_affair
		    :parameters (?m - man ?w - woman)
		    :duration (= ?duration 100)
		    :condition 
          (and
            (at start (have_met ?m ?w))
            (at start
              (or
                (married ?m)
                (married ?w)
              )
            )
            (at start (not (are_married ?m ?w)))
          )
		    :effect
		      (and
            (at end (had_affair ?m ?w))
            (at end (have_short_affair_goal ?m ?w))
          )
  )
  (:durative-action have_very_short_affair
		    :parameters (?m - man ?w - woman)
		    :duration (= ?duration 1)
		    :condition 
          (and
            (at start (have_met ?m ?w))
            (at start
              (or
                (married ?m)
                (married ?w)
              )
            )
            (at start (not (are_married ?m ?w)))
          )
		    :effect
		      (and
            (at end (had_affair ?m ?w))
            (at end (have_very_short_affair_goal ?m ?w))
          )
  )
  (:durative-action have_long_affair
		    :parameters (?m - man ?w - woman)
		    :duration (= ?duration 300)
		    :condition 
          (and
            (at start (have_met ?m ?w))
            (at start
              (or
                (married ?m)
                (married ?w)
              )
            )
            (at start (not (are_married ?m ?w)))
          )
		    :effect
		      (and
            (at end (had_affair ?m ?w))
            (at end (have_long_affair_goal ?m ?w))
          )
  )
  (:durative-action take_part_City1_battle
		    :parameters (?p - person)
		    :duration (= ?duration 20)
		    :condition
          (and
            (at start
              (or
                (take_part_City1_battle_init ?p) 
                (<= (number_thrown_take_part_City1_battle ?p) 90)
              )
            )
            (over all (soldier ?p))
            (over all (at_place City1 ?p))
            (over all (take_part_City1_battle_going_on))
            (at start (not (take_part_City1_battle_goal ?p)))
          )
		    :effect
          (and
            (at end (increase (battles_count ?p) 1))
            (at end (take_part_City1_battle_goal ?p))
          )
  )
  (:durative-action take_part_City2_battle
		    :parameters (?p - person)
		    :duration (= ?duration 50)
		    :condition
          (and
            (at start
              (or
                (take_part_City2_battle_init ?p) 
                (<= (number_thrown_take_part_City2_battle ?p) 80)
              )
            )
            (over all (soldier ?p))
            (over all (at_place City2 ?p))
            (over all (take_part_City2_battle_going_on))
            (at start (not (take_part_City2_battle_goal ?p)))
          )
		    :effect
          (and
            (at end (increase (battles_count ?p) 1))
            (at end (take_part_City2_battle_goal ?p))
          )
  )
  (:durative-action take_part_City3_battle
		    :parameters (?p - person)
		    :duration (= ?duration 40)
		    :condition
          (and
            (at start
              (or
                (take_part_City3_battle_init ?p) 
                (<= (number_thrown_take_part_City3_battle ?p) 70)
              )
            )
            (over all (soldier ?p))
            (over all (at_place City3 ?p))
            (over all (take_part_City3_battle_going_on))
            (at start (not (take_part_City3_battle_goal ?p)))
          )
		    :effect
          (and
            (at end (increase (battles_count ?p) 1))
            (at end (take_part_City3_battle_goal ?p))
          )
  )
  (:durative-action take_part_City4_battle
		    :parameters (?p - person)
		    :duration (= ?duration 4)
		    :condition
          (and
            (at start
              (or
                (take_part_City4_battle_init ?p) 
                (<= (number_thrown_take_part_City4_battle ?p) 80)
              )
            )
            (over all (soldier ?p))
            (over all (at_place City4 ?p))
            (over all (take_part_City4_battle_going_on))
            (at start (not (take_part_City4_battle_goal ?p)))
          )
		    :effect
          (and
            (at end (increase (battles_count ?p) 1))
            (at end (take_part_City4_battle_goal ?p))
          )
  )
  (:durative-action take_part_City5_battle
		    :parameters (?p - person)
		    :duration (= ?duration 10)
		    :condition
          (and
            (at start
              (or
                (take_part_City5_battle_init ?p) 
                (<= (number_thrown_take_part_City5_battle ?p) 90)
              )
            )
            (over all (soldier ?p))
            (over all (at_place City5 ?p))
            (over all (take_part_City5_battle_going_on))
            (at start (not (take_part_City5_battle_goal ?p)))
          )
		    :effect
          (and
            (at end (increase (battles_count ?p) 1))
            (at end (take_part_City5_battle_goal ?p))
          )
  )
  (:durative-action take_part_City6_battle
		    :parameters (?p - person)
		    :duration (= ?duration 6)
		    :condition
          (and
            (at start
              (or
                (take_part_City6_battle_init ?p) 
                (<= (number_thrown_take_part_City6_battle ?p) 50)
              )
            )
            (over all (soldier ?p))
            (over all (at_place City6 ?p))
            (over all (take_part_City6_battle_going_on))
            (at start (not (take_part_City6_battle_goal ?p)))
          )
		    :effect
          (and
            (at end (increase (battles_count ?p) 1))
            (at end (take_part_City6_battle_goal ?p))
          )
  )
  (:durative-action take_part_City7_battle
		    :parameters (?p - person)
		    :duration (= ?duration 7)
		    :condition
          (and
            (at start
              (or
                (take_part_City7_battle_init ?p) 
                (<= (number_thrown_take_part_City7_battle ?p) 40)
              )
            )
            (over all (soldier ?p))
            (over all (at_place City7 ?p))
            (over all (take_part_City7_battle_going_on))
            (at start (not (take_part_City7_battle_goal ?p)))
          )
		    :effect
          (and
            (at end (increase (battles_count ?p) 1))
            (at end (take_part_City7_battle_goal ?p))
          )
  )
  (:durative-action take_part_City8_battle
		    :parameters (?p - person)
		    :duration (= ?duration 40)
		    :condition
          (and
            (at start
              (or
                (take_part_City8_battle_init ?p) 
                (<= (number_thrown_take_part_City8_battle ?p) 80)
              )
            )
            (over all (soldier ?p))
            (over all (at_place City8 ?p))
            (over all (take_part_City8_battle_going_on))
            (at start (not (take_part_City8_battle_goal ?p)))
          )
		    :effect
          (and
            (at end (increase (battles_count ?p) 1))
            (at end (take_part_City8_battle_goal ?p))
          )
  )
  (:durative-action take_part_City9_battle
		    :parameters (?p - person)
		    :duration (= ?duration 4)
		    :condition
          (and
            (at start
              (or
                (take_part_City9_battle_init ?p) 
                (<= (number_thrown_take_part_City9_battle ?p) 90)
              )
            )
            (over all (soldier ?p))
            (over all (at_place City9 ?p))
            (over all (take_part_City9_battle_going_on))
            (at start (not (take_part_City9_battle_goal ?p)))
          )
		    :effect
          (and
            (at end (increase (battles_count ?p) 1))
            (at end (take_part_City9_battle_goal ?p))
          )
  )
  (:durative-action take_part_City10_battle
		    :parameters (?p - person)
		    :duration (= ?duration 40)
		    :condition
          (and
            (at start
              (or
                (take_part_City10_battle_init ?p) 
                (<= (number_thrown_take_part_City10_battle ?p) 70)
              )
            )
            (over all (soldier ?p))
            (over all (at_place City10 ?p))
            (over all (take_part_City10_battle_going_on))
            (at start (not (take_part_City10_battle_goal ?p)))
          )
		    :effect
          (and
            (at end (increase (battles_count ?p) 1))
            (at end (take_part_City10_battle_goal ?p))
          )
  )
  (:durative-action study_military_academy_in_City10
		    :parameters (?p - person)
	      :duration (= ?duration 600)
		    :condition
		      (and
            (over all (at_place City10 ?p))
          )
		    :effect
          (and
            (at start (studying_military_academy ?p))
            (at end (not (studying_military_academy ?p)))
            (at end (study_military_academy_in_City10_goal ?p)) 
            (at end (soldier ?p))
          )
  )
  (:durative-action be_ascended_to_lieutenant
		    :parameters (?p - person)
	      :duration (= ?duration 1)
		    :condition (at start (>= (battles_count ?p) 3))
		    :effect
          (and 
            (at end (lieutenant ?p))
            (at end (be_ascended_to_lieutenant_goal ?p))
          )
  )
  (:durative-action be_ascended_to_captain
		    :parameters (?p - person)
	      :duration (= ?duration 1)
		    :condition 
		      (and
		        (at start (lieutenant ?p))
            (at start (>= (battles_count ?p) 6))
          )
		    :effect
          (and 
            (at end (captain ?p))
            (at end (be_ascended_to_captain_goal ?p))
          )
  )
  (:durative-action be_ascended_to_colonel
		    :parameters (?p - person)
	      :duration (= ?duration 1)
		    :condition 
		      (and
		        (at start (captain ?p))
            (at start (>= (battles_count ?p) 10))
          )
		    :effect
          (and 
            (at end (colonel ?p))
            (at end (be_ascended_to_colonel_goal ?p))
          )
  )
  (:durative-action be_ascended_to_general
		    :parameters (?p - person)
	      :duration (= ?duration 1)
		    :condition 
		      (and
		        (at start (colonel ?p))
            (at start (>= (battles_count ?p) 15))
          )
		    :effect
          (and 
            (at end (general ?p))
            (at end (be_ascended_to_general_goal ?p))
          )
  )
  (:durative-action learn_a_trick
		    :parameters (?p - person)
	      :duration (= ?duration 60)
		    :condition (over all (studying_military_academy ?p))
		    :effect 
          (at end (learn_a_trick_goal ?p))
  )
  (:durative-action learn_other_trick
		    :parameters (?p - person)
	      :duration (= ?duration 60)
		    :condition (over all (studying_military_academy ?p))
		    :effect 
          (at end (learn_other_trick_goal ?p))
  )
)